﻿' La dll ZibaseDll.dll est développée par la société APITRONIC revendeur de la Zibase et de ses accessoires : http://www.planete-domotique.com
' L'utilisation de cette dll est totalement gratuite pour une utilisation personnelle et/ou commerciale.
' La distribution de la dll avec votre projet implique la livraison du fichier readme.txt contenant une présentation de la dll 
' ainsi qu'un lien vers notre boutique. 
Imports ZibaseDll

Public Class Form1
    Dim WithEvents zba As ZiBase = New ZiBase

    Private Sub btnExec_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExec.Click
        zba.ExecScript(TextBox1.Text)
    End Sub

    Private Sub btnRun_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRun.Click
        zba.RunScenario(TextBox2.Text)
    End Sub

    Private Sub zba_NewSensorDetected(ByVal seInfo As ZibaseDll.ZiBase.SensorInfo) Handles zba.NewSensorDetected
        ListBox2.Items.Add("NEW:" & seInfo.sID & " / " & seInfo.sType & " : " & seInfo.sValue)
        ListBox2.TopIndex = ListBox2.Items.Count - 1
    End Sub

    Private Sub zba_NewZibaseDetected(ByVal zbInfo As ZibaseDll.ZiBase.ZibaseInfo) Handles zba.NewZibaseDetected
        ListBox2.Items.Add("NZB:" & zbInfo.sLabelBase & " / " & zbInfo.lIpAddress)
        ListBox2.TopIndex = ListBox2.Items.Count - 1
    End Sub

    Private Sub zba_UpdateSensorInfo(ByVal seInfo As ZibaseDll.ZiBase.SensorInfo) Handles zba.UpdateSensorInfo
        ListBox2.Items.Add("UPD:" & seInfo.sID & " / " & seInfo.sType & " : " & seInfo.sValue)
        ListBox2.TopIndex = ListBox2.Items.Count - 1
    End Sub

    Private Sub zba_WriteMessage(ByVal sMsg As String, ByVal level As Integer) Handles zba.WriteMessage
        ListBox1.Items.Add(sMsg)
        ListBox1.TopIndex = ListBox1.Items.Count - 1
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        For i = 0 To 15
            cmbHouse.Items.Add(Chr(65 + i))
            cmbCode.Items.Add(i + 1)
        Next

        cmbProtocol.Items.Add("VISONIC433")
        cmbProtocol.Items.Add("CHACON V2")
        cmbProtocol.Items.Add("DOMIA (CHACON V1)")
        cmbProtocol.Items.Add("X10")

        For i = 0 To 100
            cmbDim.Items.Add(i)
        Next

        cmbDim.SelectedIndex = 0
        cmbProtocol.SelectedIndex = 1
        cmbHouse.SelectedIndex = 0
        cmbCode.SelectedIndex = 0

        zba.StartZB()
    End Sub

    Private Sub form1_FormClosing(ByVal sender As System.Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles Me.FormClosing
        zba.StopZB()
    End Sub

    Private Sub btnClear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClear.Click
        ListBox1.Items.Clear()
        ListBox2.Items.Clear()
    End Sub

    Private Function GetSelectedProtocol() As ZiBase.Protocol
        Select Case cmbProtocol.SelectedIndex
            Case 0
                GetSelectedProtocol = ZiBase.Protocol.PROTOCOL_VISONIC433
            Case 1
                GetSelectedProtocol = ZiBase.Protocol.PROTOCOL_CHACON
            Case 2
                GetSelectedProtocol = ZiBase.Protocol.PROTOCOL_DOMIA
            Case 3
                GetSelectedProtocol = ZiBase.Protocol.PROTOCOL_X10

        End Select
    End Function

    Private Sub btnON_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnON.Click
        zba.SendCommand(cmbHouse.SelectedItem & cmbCode.SelectedItem, ZiBase.State.STATE_ON, 0, GetSelectedProtocol(), 1)
    End Sub

    Private Sub btnOFF_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOFF.Click
        zba.SendCommand(cmbHouse.SelectedItem & cmbCode.SelectedItem, ZiBase.State.STATE_OFF, 0, GetSelectedProtocol(), 1)
    End Sub

    Private Sub btnDIM_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDIM.Click
        zba.SendCommand(cmbHouse.SelectedItem & cmbCode.SelectedItem, ZiBase.State.STATE_DIM, cmbDim.SelectedIndex, GetSelectedProtocol(), 1)
    End Sub

    Private Sub btnRead_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRead.Click
        Dim sei As ZiBase.SensorInfo

        sei = zba.GetSensorInfo(TextBox4.Text, TextBox3.Text)

        MsgBox("Valeur pour le capteur " & sei.sID & "(" & sei.sType & ") = " & sei.sValue)
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Close()
    End Sub

    Private Sub PictureBox1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PictureBox1.Click
        Process.Start("http://www.zodianet.com")
    End Sub

    Private Sub PictureBox2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PictureBox2.Click
        Process.Start("http://www.planete-domotique.com")
    End Sub
End Class
